var express = require('express');
var router = express.Router();
const passport = require('../passport-config');
const Account = require("../models/account");

/* GET home page. */
router.get('/', function(req, res, next) {
    res.render('authentification');
});

router.post('/authentification', passport.authenticate('local', {
    successRedirect: '/dashboard',
    failureRedirect: '/'
}));

router.get('/dashboard', isAuthenticated, function(req, res, next) {
    res.render('deconnexion');
});

router.get('/register', function(req, res) {
    res.render('register', { });
});

router.post('/register', function(req, res) {
    Account.register(new Account({ username : req.body.username }), req.body.password, function(err, account) {
        if (err) {
            return res.render('register', { account : account });
        }

        passport.authenticate('local')(req, res, function () {
            res.redirect('/');
        });
    });
});

router.get('/logout', isAuthenticated, function(req, res, next) {
    req.logout(function(err) {
        if (err) {
            return next(err);
        }
        res.redirect('/');
    });
});

function isAuthenticated(req, res, next) {
    if (req.isAuthenticated()) {
        return next();
    }
    res.redirect('/');
}

module.exports = router;